unit u_element;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  u_data, Buttons;

type
  TElementForm = class(TForm)
    constructor Create(AOwner : TComponent; pPSE : TList);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
    PSE      : TList;
    pElement : TElement;
  public
    { Public-Deklarationen }
    function getElement : TElement;
  end;

var
  ElementForm: TElementForm;

implementation

{$R *.DFM}

const BTNSIZE_X = 40;
      BTNSIZE_Y = 40;
      SPACESIZE =  2;


constructor TElementForm.Create(AOwner : TComponent; pPSE : TList);
begin
  inherited Create(AOwner);
  PSE:= pPSE;
  pElement:= nil;
end;

procedure TElementForm.FormCreate(Sender: TObject);
var i,x,y,z   : integer;
    pElement  : TElement;
    pSpeedBTN : TSpeedButton;
begin
  pElement:= nil;
  x:= Width - ClientWidth;
  y:= Height - ClientHeight;
  Width:=  18 * BTNSIZE_X + 17 * SPACESIZE + x;
  Height:= 10 * BTNSIZE_Y +  9 * SPACESIZE + y;

  if (PSE <> nil) and (PSE.Count > 0) then
  begin
    x:= 1;
    y:= 1;
    z:= 1;
    for i:= 0 to PSE.count-1 do
    begin
      pElement:= PSE.Items[i];
      if pElement <> nil then
      begin
        if not(pElement.Lanthanoide) and not(pElement.Actinoide) then
        begin
          if pElement.Position > 0 then
          begin
            if z < pElement.Periode then
            begin
              inc(z);
              x:= 1;
              y:= y + BTNSIZE_Y + SPACESIZE;
            end;
            pSpeedBTN:= TSpeedButton.Create(self);
            pSpeedBTN.Left:= x;
            pSpeedBTN.Top:= y;
            pSpeedBTN.Width:= BTNSIZE_X;
            pSpeedBTN.Height:= BTNSIZE_Y;
            pSpeedBTN.Caption:= pElement.Symbol;
            pSpeedBTN.Hint:= pElement.Name;
            pSpeedBTN.Font.Height:= BTNSIZE_Y div 2;
            pSpeedBTN.Font.Style:= [fsBOLD];
            pSpeedBTN.Tag:= pElement.Position;
            pSpeedBTN.OnClick:= SpeedButtonClick;
            InsertControl(pSpeedBTN);
          end;
          x:= x + BTNSIZE_X + SPACESIZE;
        end;
      end;
    end;

    //Lanthanoide
    y:= y + BTNSIZE_Y + SPACESIZE;
    y:= y + BTNSIZE_Y + SPACESIZE;
    x:= 1;
    x:= x + BTNSIZE_X + SPACESIZE;
    x:= x + BTNSIZE_X + SPACESIZE;
    for i:= 0 to PSE.count-1 do
    begin
      pElement:= PSE.Items[i];
      if pElement <> nil then
      begin
        if (pElement.Lanthanoide) then
        begin
          if pElement.Position > 0 then
          begin
            pSpeedBTN:= TSpeedButton.Create(self);
            pSpeedBTN.Left:= x;
            pSpeedBTN.Top:= y;
            pSpeedBTN.Width:= BTNSIZE_X;
            pSpeedBTN.Height:= BTNSIZE_Y;
            pSpeedBTN.Caption:= pElement.Symbol;
            pSpeedBTN.Hint:= pElement.Name;
            pSpeedBTN.Font.Height:= BTNSIZE_Y div 2;
            pSpeedBTN.Font.Style:= [fsBOLD];
            pSpeedBTN.Tag:= pElement.Position;
            pSpeedBTN.OnClick:= SpeedButtonClick;
            InsertControl(pSpeedBTN);
          end;
          x:= x + BTNSIZE_X + SPACESIZE;
        end;
      end;
    end;

    //Actinoide
    y:= y + BTNSIZE_Y + SPACESIZE;
    x:= 1;
    x:= x + BTNSIZE_X + SPACESIZE;
    x:= x + BTNSIZE_X + SPACESIZE;
    for i:= 0 to PSE.count-1 do
    begin
      pElement:= PSE.Items[i];
      if pElement <> nil then
      begin
        if (pElement.Actinoide) then
        begin
          if pElement.Position > 0 then
          begin
            pSpeedBTN:= TSpeedButton.Create(self);
            pSpeedBTN.Left:= x;
            pSpeedBTN.Top:= y;
            pSpeedBTN.Width:= BTNSIZE_X;
            pSpeedBTN.Height:= BTNSIZE_Y;
            pSpeedBTN.Caption:= pElement.Symbol;
            pSpeedBTN.Hint:= pElement.Name;
            pSpeedBTN.Font.Height:= BTNSIZE_Y div 2;
            pSpeedBTN.Font.Style:= [fsBOLD];
            pSpeedBTN.Tag:= pElement.Position;
            pSpeedBTN.OnClick:= SpeedButtonClick;
            InsertControl(pSpeedBTN);
          end;
          x:= x + BTNSIZE_X + SPACESIZE;
        end;
      end;
    end;
  end;
end;

procedure TElementForm.FormDestroy(Sender: TObject);
var i : integer;
begin
  i:= ComponentCount -1;
  while i > 0 do
  begin
    if (Components[i] is TSpeedButton) then
    begin
      RemoveControl(Components[i] as TSpeedButton);
      (Components[i] as TSpeedButton).Free;
    end;
    dec(i);
  end;

end;

procedure TElementForm.SpeedButtonClick(Sender: TObject);
var i,x : integer;
    pE  : TElement;
begin
  pElement:= nil;
  if (Sender is TSpeedButton) then
  begin
    if ((Sender as TSpeedButton).TAG > 0) then
    begin
     x:= (Sender as TSpeedButton).TAG;
     i:= 0;
     while i < PSE.Count do
     begin
       pE:= PSE.Items[i];
       if (pE <> nil) and (pE.Position = x) then
       begin
         pElement:= PSE.Items[i];
         break;
       end;
       inc(i);
      end;
    end;
  end;
  Close;
end;

function TElementForm.getElement : TElement;
begin
  result:= pElement;
end;

end.
