unit u_inifile;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, u_myfloat;

const k_MEMO    = 'MEMO';
      k_EINHEIT = 'EINHEIT';


type
  TIniFile = class(TObject)
  private
    { Private-Deklarationen }
    strlist   : TStringList;
    ininame   : string;
    b_memo    : boolean;
    b_einheit : boolean;
    procedure readini(filename : string);
    function getBool(s : string) : boolean;
    function getInt(s : string) : integer;
    function getFloat(s : string) : double;
  public
    { Public-Deklarationen }
    constructor Create(filename : string);
    destructor destroy;
    function readmemofunction : boolean;
    function readeinheit : boolean;
  end;


implementation

constructor TIniFile.Create(filename : string);
begin
  inherited Create;
  ininame:= filename;
  strlist:= TStringList.create;
  readini(filename);
end;

destructor TIniFile.destroy;
begin
  strlist.free;
  inherited;
end;

procedure TIniFile.readini(filename : string);
var s,sx : string;
    n,i  : integer;
begin
  if (fileexists(filename)) then
  begin
    strlist.clear;
    strlist.LoadFromFile(filename);

    if strlist.Count > 0 then
    begin
      for i:= 0 to strlist.Count-1 do
      begin
        s:= strlist.Strings[i];
        n:= pos(':',s);
        if n > 0 then
        begin
          sx:= uppercase(copy(s,1,n-1));
          delete(s,1,n);

          if (sx = k_MEMO) then b_memo:= getBool(s);
          if (sx = k_EINHEIT) then b_einheit:= getBool(s);
        end;

      end;
    end;

  end;
end;

function TIniFile.getBool(s : string) : boolean;
var i : integer;
begin
  i:= strtointdef(s,0);
  if i > 0 then getBool:= true
           else getBool:= false;
end;

function TIniFile.getInt(s : string) : integer;
begin
  getInt:= strtointdef(s,0);
end;

function TIniFile.getFloat(s : string) : double;
begin
  getFloat:= my_strtofloat(s);
end;

function TIniFile.readmemofunction : boolean;
begin
  readmemofunction:= b_memo;
end;

function TIniFile.readeinheit : boolean;
begin
  readeinheit:= b_einheit;
end;

end.
