{$A+,B-,C+,D-,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE GUI}
unit u_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ToolWin, ComCtrls, Menus, Clipbrd,
  u_myfloat, u_data, u_inifile, u_element, u_viewelement, u_math, u_about, u_hilfe;

const INIFILE = 'FED.ini';
      PSEFILE = 'PSE.ini';
      WORKDIR = 'WORK';

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    FormelIMG: TImage;
    ToolBar1: TToolBar;
    ElementBTN: TSpeedButton;
    ZahlBTN: TSpeedButton;
    ZahlTiefBTN: TSpeedButton;
    DelBTN: TSpeedButton;
    ElementDatenBTN: TSpeedButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    CalcBTN: TButton;
    MainMenu1: TMainMenu;
    MDatei: TMenuItem;
    MLaden: TMenuItem;
    MSave: TMenuItem;
    MHilfe: TMenuItem;
    MHilfe1: TMenuItem;
    MInfo: TMenuItem;
    N1: TMenuItem;
    MClose: TMenuItem;
    ErgebnisED: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure ElementViewBTNClick(Sender: TObject);
    procedure ElementBTNClick(Sender: TObject);
    procedure DelBTNClick(Sender: TObject);
    procedure ZahlBTNClick(Sender: TObject);
    procedure ZahlTiefBTNClick(Sender: TObject);
    procedure FormelIMGMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
    procedure FormelIMGMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GroupBox1Click(Sender: TObject);
    procedure CalcBTNClick(Sender: TObject);
    procedure MLadenClick(Sender: TObject);
    procedure MSaveClick(Sender: TObject);
    procedure MHilfe1Click(Sender: TObject);
    procedure MInfoClick(Sender: TObject);
    procedure MCloseClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private-Deklarationen }
    TXTPOSH,TXTPOSN,TXTPOSW,TXTSPACE : integer;
    TXTZeiger : integer;
    Tiefpos   : boolean;
    skey      : integer;
    TXTstr    : string;
    b_TXT     : boolean;
    procedure ReadPSE;
    procedure ClearPSE;
    function TStr(var s : string) : string;
    procedure Clear_Input;
    procedure ClearWindow;
    procedure WriteDaten(X : TDaten);
    procedure DelDaten;
    procedure DelDaten2;
    procedure ShowCursor;
    procedure ClearErgebnis;
    function  FindElement(s : string) : TElement;
    function  upperstring(s : string) : string;
  public
    { Public-Deklarationen }
    pfad     : string;
    IniDatei : TIniFile;
    PSE      : TList;
    Daten    : TList;
    function Berechnen : string;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  initfloat;
  pfad:= ExtractFilePath(ParamStr(0));
  if length(pfad) < 3 then pfad:= pfad + '\';

  IniDatei:= TIniFile.Create(Pfad + INIFILE);

  PSE:= TList.create;
  readPSE;

  Daten:= TList.create;
  Clear_Input;
  skey:= 0;
  TXTstr:= '';
  b_TXT:= false;
//  Application.HintHidePause:= 2000;
//  Application.HintShortPause:= 100;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  ClearPSE;
  PSE.Free;
  Daten.Free;
  Daten:= nil;
  IniDatei.Free;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  Height:= 350;  //Limitierung
  if Width < 515 then Width:= 515;

  FormelImg.Picture:= nil;
  FormelIMG.Canvas.Pen.Color:= clBlack;
  FormelIMG.Canvas.Brush.Color:= clWhite;
  FormelIMG.Canvas.Font.Name:= 'ARIAL';
  FormelIMG.Canvas.Font.Height:= 20;
  FormelIMG.Canvas.Font.Style:= [fsBOLD];
  FormelIMG.Canvas.Font.Color:= clblack;
  FormelIMG.Canvas.FillRect(FormelIMG.Canvas.ClipRect);
  WriteDaten(nil);
end;

procedure TMainForm.ReadPSE;
var strlist  : TStringList;
    pElement : TElement;
    s,sx     : string;
    i        : integer;
begin
  PSE.Clear;
  if (fileexists(pfad + PSEFILE)) then
  begin
    strlist:= TStringList.create;
    strlist.LoadFromFile(Pfad + PSEFILE);
    if strlist.Count > 0 then
    begin
      for i:= 0 to strlist.Count-1 do
      begin
        s:= strlist.Strings[i];
        if s <> '' then
        begin
          new(pElement);
          pElement.Position:=    strtointdef(TStr(s),0);
          pElement.Periode:=     strtointdef(TStr(s),0);
          pElement.Hauptgruppe:= strtointdef(TStr(s),0);
          if (strtointdef(TStr(s),0) = 0) then pElement.Nebengruppe:= false
                                          else pElement.Nebengruppe:= true;

          if (strtointdef(TStr(s),0) = 0) then pElement.Lanthanoide:= false
                                          else pElement.Lanthanoide:= true;

          if (strtointdef(TStr(s),0) = 0) then pElement.Actinoide:= false
                                          else pElement.Actinoide:= true;

          pElement.Symbol:= TStr(s);
          pElement.Name:= TStr(s);

          sx:= TStr(s);
          pElement.Gewicht:= my_strtodouble(sx);
          PSE.Add(pElement);
        end;
      end;
    end;
    strlist.Free;
  end;
end;

function TMainForm.upperstring(s : string) : string;
var sx : string;
    i  : integer;
begin
  sx:= uppercase(s);
  if length(sx) > 0 then
  begin
    for i:= 1 to length(sx) do
    begin
      if sx[i] = '' then sx[i]:= '';
      if sx[i] = '' then sx[i]:= '';
      if sx[i] = '' then sx[i]:= '';
    end;
  end;
  upperstring:= sx;
end;

function TMainForm.FindElement(s : string) : TElement;
var searchstr,elementstr1,elementstr2 : string;
    pElement : TElement;
    i        : integer;
begin
  FindElement:= nil;
  searchstr:= upperstring(s);
  if (PSE <> nil) and (PSE.Count > 0) then
  begin
    for i:= 0 to PSE.Count-1 do
    begin
      pElement:= PSE.Items[i];
      if pElement <> nil then
      begin
        elementstr1:= upperstring(pElement.Symbol);
        elementstr2:= upperstring(pElement.Name);

        if (elementstr1 = searchstr) or (elementstr2 = searchstr) then
        begin
          FindElement:= pElement;
          break;
        end;
      end;
    end;
  end;
end;

function TMainForm.TStr(var s : string) : string;
var sx : string;
    i  : integer;
begin
  i:= pos('|',s);
  if i > 0 then
  begin
    sx:= copy(s,1,i-1);
    delete(s,1,i);
  end
  else begin
         sx:= s;
         s:= '';
       end;

  TStr:= sx;
end;

procedure TMainForm.ClearPSE;
var i        : integer;
    pElement : TElement;
begin
  if PSE.Count > 0 then
  begin
    for i:= 0 to PSE.Count-1 do
    begin
      pElement:= PSE.Items[i];
      if pElement <> nil then dispose(pElement);
    end;
  end;
  PSE.Clear;
end;

procedure TMainForm.ElementViewBTNClick(Sender: TObject);
var DLG : TElementViewForm;
begin
  DLG:= TElementViewForm.Create(self,PSE,IniDatei);
  DLG.ShowModal;
  DLG.Free;
end;

procedure TMainForm.ElementBTNClick(Sender: TObject);
var DLG      : TElementForm;
    pElement : TElement;
    pData    : TDaten;
begin
  ZahlTiefBTNClick(self);
  DLG:= TElementForm.Create(self,PSE);
  DLG.ShowModal;
  pElement:= DLG.getElement;
  DLG.Free;
  if pElement <> nil then
  begin
    new(pData);
    pData.xs:= pElement.Symbol;
    pData.size:= FormelIMG.Canvas.TextWidth(pElement.Symbol);
    pData.value:= pElement.Gewicht;
    pData.hint:= pElement.Name;
    pData.typ:= Element;
    WriteDaten(pData);
  end;
  ClearErgebnis;
end;

procedure TMainForm.Clear_Input;
var i : integer;
    X : TDaten;
begin
  FormelIMG.Canvas.Pen.Color:= clBlack;
  FormelIMG.Canvas.Brush.Color:= clWhite;
  FormelIMG.Canvas.Font.Name:= 'ARIAL';
  FormelIMG.Canvas.Font.Height:= 20;
  FormelIMG.Canvas.Font.Style:= [fsBOLD];
  FormelIMG.Canvas.Font.Color:= clblack;
  FormelIMG.Canvas.FillRect(FormelIMG.Canvas.ClipRect);
  TXTPOSH:= (FormelIMG.Height div 2) - (FormelIMG.Canvas.TextHeight('X') div 2);
  TXTPOSN:= TXTPOSH + (FormelIMG.Canvas.TextHeight('X') div 2);
  TXTPOSW:= FormelIMG.Canvas.TextWidth('W');
  TXTSPACE:= 3;
  TXTZeiger:= 1;

  if Daten.Count > 0 then
  begin
    for i:= 0 to Daten.Count-1 do
    begin
      X:= Daten.Items[i];
      if X <> nil then dispose(X);
    end;
  end;
  Daten.Clear;

  ZahlBTNClick(Self);
  ShowCursor;
  ClearErgebnis;
end;

procedure TMainForm.ShowCursor;
var xpos  : integer;
    i,n   : integer;
    pData : TDaten;
begin
  if (Daten <> nil) then
  begin
    xpos:= 0;
    n:= TXTPOSW;

    for i:= 0 to TXTZeiger-2 do
    begin
      if i < Daten.Count then
      begin
        pData:= Daten.Items[i];
        if pData <> nil then xpos:= xpos + pData.size + TXTSPACE;
      end;
    end;

    if TXTZeiger-1 < Daten.Count then
    begin
      pData:= Daten.Items[TXTZeiger-1];
      if pData <> nil then n:= pData.size;
    end;

    FormelIMG.Canvas.Font.Color:= clblack;
    FormelIMG.Canvas.Font.Height:= 20;
    FormelIMG.Canvas.Font.Style:= [fsBOLD];

    FormelIMG.Canvas.MoveTo((xpos),TXTPOSH + FormelIMG.Canvas.TextHeight('X') + 10);
    FormelIMG.Canvas.LineTo(xpos + n,TXTPOSH + FormelIMG.Canvas.TextHeight('X') + 10);
  end;
end;

procedure TMainForm.ClearWindow;
begin
  FormelIMG.Canvas.Font.Color:= clblack;
  FormelIMG.Canvas.Font.Height:= 20;
  FormelIMG.Canvas.Font.Style:= [fsBOLD];
  FormelIMG.Canvas.FillRect(FormelIMG.Canvas.ClipRect);
end;

procedure TMainForm.WriteDaten(X : TDaten);
var H,i,xpos : integer;
    pData : TDaten;
begin
  if X <> nil then
  begin
    if Daten.Count < TXTZeiger then
    begin
      Daten.Add(X);
      inc(TXTZeiger);
    end
    else begin
           Daten.Insert(TXTZeiger-1,X);
           inc(TXTZeiger);
         end;
  end;

  ClearWindow;
  xpos:= 0;

  if (Daten <> nil) and (Daten.Count > 0) then
  begin
    for i:= 0 to Daten.Count-1 do
    begin
      pData:= Daten.Items[i];
      if pData <> nil then
      begin
        case pData.typ of
        Leer:          begin
                         FormelIMG.Canvas.TextOut(xpos,TXTPOSH,' ');
                       end;
        Mal:           begin
                         FormelIMG.Canvas.TextOut(xpos,TXTPOSH,'*');
                       end;
        Element,
        Klammer1,
        Multiplikator: begin
                         FormelIMG.Canvas.TextOut(xpos,TXTPOSH,pData.xs);
                       end;
        Klammer2:      begin
                         H:= FormelIMG.Canvas.Font.Height;
                         FormelIMG.Canvas.Font.Height:= FormelIMG.Canvas.Font.Height * 2;
                         FormelIMG.Canvas.TextOut(xpos,TXTPOSH - H div 2,pData.xs);
                         FormelIMG.Canvas.Font.Height:= H;
                       end;
        Zaehler:       begin
                         FormelIMG.Canvas.TextOut(xpos,TXTPOSN,pData.xs);
                       end;
        end; //case
        xpos:= xpos + pData.size + TXTSPACE;
      end;
    end;
  end;
  ShowCursor;
end;

procedure TMainForm.DelDaten; //entfernen
var  pData : TDaten;
begin
  if (TXTZeiger > 0) and (TXTZeiger <= Daten.Count+1) then
  begin
    pData:= Daten.Items[TXTZeiger-1];
    if pData <> nil then dispose(pData);
    Daten.Delete(TXTZeiger-1);
    WriteDaten(nil);
  end;
end;

procedure TMainForm.DelDaten2;  //Backspace
var  pData : TDaten;
begin
  if (TXTZeiger > 1) and (TXTZeiger <= Daten.Count+1) then
  begin
    pData:= Daten.Items[TXTZeiger-2];
    if pData <> nil then dispose(pData);
    Daten.Delete(TXTZeiger-2);
    dec(TXTZeiger);
    WriteDaten(nil);
  end;
end;

procedure TMainForm.DelBTNClick(Sender: TObject);
begin
  Clear_Input;
end;

procedure TMainForm.ZahlBTNClick(Sender: TObject);
begin
  Tiefpos:= false;
  ZahlBTN.Enabled:= false;
  ZahlTiefBTN.Enabled:= true;
end;

procedure TMainForm.ZahlTiefBTNClick(Sender: TObject);
begin
  Tiefpos:= true;
  ZahlBTN.Enabled:= true;
  ZahlTiefBTN.Enabled:= false;
end;

procedure TMainForm.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
var pData    : TDaten;
    pElement : TElement;
begin
   //Tastatursonderfunktionen
  if (skey = 4) and
     ((CHR(Msg.CharCode) in ['a'..'z','A'..'Z']) or
      (Msg.CharCode = 186) or (Msg.CharCode = 192) or (Msg.CharCode = 222)) then skey:= 0;

  case Msg.CharCode of
   16:   begin  //Shift
           skey:= skey or 1;
         end;
   17:   begin  //STRG
           skey:= skey or 2;
         end;
   18:   begin  //ALT Gr
           skey:= skey or 4;
           b_TXT:= false;
         end;
   33:   begin  //Bild hoch
           ZahlBTNClick(self);
           Handled:=true;
           b_TXT:= false;
         end;
   34:   begin  //Bild runter
           ZahltiefBTNClick(self);
           Handled:=true;
           b_TXT:= false;
         end;
   38:   begin  //Pfeil hoch
           ZahlBTNClick(self);
           Handled:=true;
           b_TXT:= false;
         end;
   40:   begin  //Pfeil runter
           ZahltiefBTNClick(self);
           Handled:=true;
           b_TXT:= false;
         end;
   37:   begin  //Pfeil links
           if TXTZeiger > 1 then dec(TXTZeiger);
           WriteDaten(nil);
           Handled:= true;
           b_TXT:= false;
         end;
   39:   begin  //Pfeil rechts
           if TXTZeiger < Daten.Count+1 then inc(TXTZeiger);
           WriteDaten(nil);
           Handled:= true;
           b_TXT:= false;
         end;
   45:   begin  //Einfuegen
         end;
   46:   begin  //Entfernen
           ClearErgebnis;
           DelDaten;
           Handled:= true;
           b_TXT:= false;
         end;
    8:   begin  //Del
           ClearErgebnis;
           DelDaten2;
           Handled:= true;
           b_TXT:= false;
         end;
   35:   begin  //Ende
           TXTZeiger:= Daten.Count+1;
           WriteDaten(nil);
           Handled:= true;
           b_TXT:= false;
         end;
   36:   begin  //Pos
           TXTZeiger:= 1;
           WriteDaten(nil);
           Handled:= true;
           b_TXT:= false;
         end;
  48,49,
  50,51,
  52,53,
  54,55,
  56,57: begin
           ClearErgebnis;
           if skey = 0 then
           begin
             new(pData);
             pData.value:= 0;
             pData.xs:= inttostr(Msg.CharCode - 48);
             if Tiefpos then pData.typ:= Zaehler else pData.typ:= Multiplikator;
             pData.size:= FormelIMG.Canvas.TextWidth('8');
             WriteDaten(pData);
           end;

           if (Msg.CharCode >= 56) then
           begin
             ZahlBTNClick(self);
             if ((skey and 1) > 0) then
             begin
               new(pData);
               pData.value:= 0;
               if Msg.CharCode = 56 then pData.xs:= '(' else pData.xs:= ')';
               pData.typ:= Klammer1;
               pData.size:= FormelIMG.Canvas.TextWidth('(');
               WriteDaten(pData);
             end;

             if ((skey and 4) > 0) then
             begin
               new(pData);
               pData.value:= 0;
               if Msg.CharCode = 56 then pData.xs:= '[' else pData.xs:= ']';
               pData.typ:= Klammer2;
               pData.size:= FormelIMG.Canvas.TextWidth('[[');
               WriteDaten(pData);
             end;
           end;

           skey:= 0;
           Handled:= true;
           b_TXT:= false;
         end;
 188,
 190:    begin
           if Tiefpos then
           begin
             ClearErgebnis;
             if skey = 0 then
             begin
               new(pData);
               pData.value:= 0;
               pData.xs:= '.';
               pData.typ:= Zaehler;
               pData.size:= FormelIMG.Canvas.TextWidth('8');
               WriteDaten(pData);
             end;
           end;
           skey:= 0;
           Handled:= true;
           b_TXT:= false;
         end;
  32:    begin
           ZahlBTNClick(self);
           skey:= 0;
           new(pData);
           pData.xs:= ' ';
           pData.value:= 0;
           pData.typ:= Leer;
           pData.size:= FormelIMG.Canvas.TextWidth(' ');
           WriteDaten(pData);
           Handled:= true;
           b_TXT:= false;
         end;
 187:    begin
           ZahlBTNClick(self);
           if ((skey and 1) > 0) then
           begin
             new(pData);
             pData.xs:= '*';
             pData.value:= 0;
             pData.typ:= Mal;
             pData.size:= FormelIMG.Canvas.TextWidth('*');
             WriteDaten(pData);
             skey:= 0;
             Handled:= true;
             b_TXT:= false;
           end;
         end;
  27:    begin
           TXTstr:= '';
           b_TXT:= false;
           Handled:= true;
         end;
  13:    begin
           if b_TXT then
           begin
             pElement:= findelement(TXTstr); //Element einfuegen
             if pElement <> nil then
             begin
               new(pData);
               pData.xs:= pElement.Symbol;
               FormelIMG.Canvas.Font.Height:= 20;
               FormelIMG.Canvas.Font.Style:= [fsBOLD];
               pData.size:=  FormelIMG.Canvas.TextWidth(pElement.Symbol);
               pData.value:= pElement.Gewicht;
               pData.hint:= pElement.Name;
               pData.typ:= Element;
               WriteDaten(pData);
             end;
             TXTstr:= '';
             b_TXT:= false;
             WriteDaten(nil);
             Handled:= true;
           end;
         end;
  end;//Case

  if (skey = 0) or (skey = 1) then
  begin
    if ((CHR(Msg.CharCode) in ['a'..'z','A'..'Z']) or
        (Msg.CharCode = 186) or (Msg.CharCode = 192) or (Msg.CharCode = 222)) then
    begin
      if not(b_TXT) then
      begin
        b_TXT:= true;
        TXTstr:= '';
      end;

      case (Msg.CharCode) of
      186: TXTstr:= TXTstr + '';
      192: TXTstr:= TXTstr + '';
      222: TXTstr:= TXTstr + '';
      else TXTstr:= TXTstr + CHR(Msg.CharCode);
      end;

      Handled:= true;
      skey:= 0;
      ZahltiefBTNClick(self);

      FormelIMG.Canvas.Font.Height:= 15;
      FormelIMG.Canvas.Font.Style:= [];
      FormelIMG.Canvas.Font.Color:= clblue;

      FormelIMG.Canvas.TextOut(1,TXTPOSH+ 70,TXTstr + '  <ENTER>');
    end;
  end;
end;

procedure TMainForm.FormelIMGMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var xpos,xpos1,xpos2,i : integer;
    pData              : TDaten;
    s                  : string;
    pPoint             : TPoint;
begin
  xpos:= 0;
  s:= '';

  if (Daten.Count > 0) then
  begin
    for i:= 0 to Daten.Count-1 do
    begin
      pData:= Daten.Items[i];
      if (pData <> nil) then
      begin
        if (X >= xpos) then
        begin
          xpos1:= xpos;
          xpos2:= xpos1 + pData.size;
          if (X <= xpos2) then s:= pData.hint;
        end;
        xpos:= xpos + pData.size + TXTSPACE;
      end;
    end;

    if (s <> '') then
    begin
      FormelIMG.Hint:= s;
      pPoint.x:= X;
      pPoint.y:= Y + 30;
        Application.ActivateHint(pPoint);
    end
    else FormelIMG.Hint:= '';
  end;
end;

procedure TMainForm.FormelIMGMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  FormelIMGMouseMove(Sender,Shift,x,y);
end;

procedure TMainForm.GroupBox1Click(Sender: TObject);
begin
  CalcBTNClick(Sender);
end;

procedure TMainForm.ClearErgebnis;
begin
  ErgebnisED.Text:= '';
end;
procedure TMainForm.CalcBTNClick(Sender: TObject);
begin
  ErgebnisED.Text:= Berechnen;
end;

function TMainForm.Berechnen : string;
var i,Klammer,Klammer_x1,Klammer_x2 : integer;
    pData  : TDaten;
    sValue : string;
    Formel: TFormel;
    b_Zahl,b_Multiplicator : boolean;
begin
  Formel:= TFormel.Create;
  sValue:= '';
  b_Zahl:= false;
  b_Multiplicator:= false;
  Klammer:= 0;
  Klammer_x1:= 0;
  Klammer_x2:= 0;

  if (Daten.Count > 0) then
  begin
    for i:= 0 to Daten.Count-1 do
    begin
      pData:= Daten.Items[i];
      if pData <> nil then
      begin
        if (b_Zahl) and (pData.typ <> Zaehler) then
        begin
          Formel.Add('*');
          Formel.Add(strtointdef(sValue,0));
          sValue:= '';
          b_Zahl:= false;
        end;

        if (b_Multiplicator) and (pData.typ <> Multiplikator) then
        begin
          Formel.Add(strtointdef(sValue,0));
          Formel.Add('*(');
          inc(Klammer);
          sValue:= '';
          b_Multiplicator:= false;
        end;

        case pData.typ of
        Leer:            begin
                         end;
        Mal:             begin
                           if (Klammer > 0) then
                           begin
                             dec(Klammer);
                             Formel.Add(')');
                           end;
                           Formel.Add('+');
                         end;
        Element:         begin
                           if Formel.Count > 0 then
                           begin
                             if Formel.getLastItemIsValue then Formel.Add('+');
                           end;
                           Formel.Add(pData.Value);
                         end;
        Klammer1:        begin
                           if pData.xs = '(' then
                           begin
                             inc(Klammer_x1);
                             Formel.Add('+');
                           end
                           else dec(Klammer_x1);
                           Formel.Add(pData.xs);
                         end;
        Klammer2:        begin
                           if pData.xs = '[' then
                           begin
                             inc(Klammer_x2);
                             Formel.Add('+(');
                           end
                           else begin
                                  dec(Klammer_x2);
                                  Formel.Add(')');
                                end;
                         end;
        Multiplikator:   begin
                           b_Multiplicator:= true;
                           sValue:= sValue + pData.xs;
                         end;
        Zaehler:         begin
                           b_Zahl:= true;
                           sValue:= sValue + pData.xs;
                         end;
        end; //case
      end;
    end;

    if (b_Zahl) then
    begin
      Formel.Add('*');
//      Formel.Add(strtointdef(sValue,0));
      Formel.Add(my_strtofloat(sValue));
      sValue:= '';
      b_Zahl:= false;
    end;

    if Klammer > 0 then
    begin
      Formel.Add(')');
      dec(Klammer);
    end;

    if (Klammer <> 0) or (Klammer_x1 <> 0) or (Klammer_x2 <> 0) then Formel.Clear;

    if Formel.Count > 0 then
    begin
//      sValue:= Formel.getString;

      Formel.Calculate;
      sValue:= my_doubletostr(Formel.getValue,4,5);

      if IniDatei.readmemofunction then
      begin
        if IniDatei.readeinheit then Clipboard.AsText:= sValue + ' g/mol'
                                else Clipboard.AsText:= sValue;
      end;
    end;

  end;
  Formel.Free;
  result:= sValue;
end;

procedure TMainForm.MLadenClick(Sender: TObject);
var DLG      : TOpenDialog;
    strlist  : TStringList;
    pData    : TDaten;
    pElement : TElement;
    s        : string;
    i        : integer;
begin
  Clear_Input;
  DLG:= TOpenDialog.Create(self);
  DLG.InitialDir:= Pfad + WORKDIR;
  DLG.DefaultExt:= '.txt';
  DLG.Title:= 'Formel laden';
  DLG.Filter:= 'FORMEL|*.txt';
  DLG.FilterIndex:= 0;
  if DLG.Execute then
  begin
    strlist:= TStringlist.Create;
    strlist.LoadFromFile(DLG.Filename);
    if strlist.count > 0 then
    begin
      for i:= 0 to strlist.count-1 do
      begin
        s:= strlist.Strings[i];

        if s <> '' then
        begin
          new(pData);

          if s[1] = '|' then
          begin
            pData.xs:= s[2];
            pData.value:= 0.0;
            pData.typ:= Multiplikator;
            pData.hint:= '';
            pData.size:= FormelIMG.Canvas.TextWidth('8');
          end
          else begin
                 pData.value:= 0.0;
                 pData.hint:= '';
                 pData.size:= FormelIMG.Canvas.TextWidth('X');

                 if s[1] in ['0'..'9','.',','] then
                 begin
                   pData.xs:= s[1];
                   pData.typ:= Zaehler;
                   pData.size:= FormelIMG.Canvas.TextWidth('8');
                 end;

                 if s[1] in [' '] then
                 begin
                   pData.xs:= s[1];
                   pData.typ:= Leer;
                   pData.size:= FormelIMG.Canvas.TextWidth(' ');
                 end;

                 if s[1] in ['*'] then
                 begin
                   pData.xs:= s[1];
                   pData.typ:= Mal;
                   pData.size:= FormelIMG.Canvas.TextWidth('*');
                 end;

                 if s[1] in ['(',')'] then
                 begin
                   pData.xs:= s[1];
                   pData.typ:= Klammer1;
                   pData.size:= FormelIMG.Canvas.TextWidth('(');
                 end;

                 if s[1] in ['[',']'] then
                 begin
                   pData.xs:= s[1];
                   pData.typ:= Klammer2;
                   pData.size:= FormelIMG.Canvas.TextWidth('[[');
                 end;

                 if s[1] in ['a'..'z','A'..'Z','','','','','',''] then
                 begin
                   pData.xs:= 'XXX';
                   pData.hint:= 'FEHLER';
                   pData.value:= 0;
                   pData.typ:= Element;
                   pData.size:= FormelIMG.Canvas.TextWidth('XXX');

                   pElement:= findElement(s);
                   if pElement <> nil then
                   begin
                     pData.xs:= pElement.Symbol;
                     pData.hint:= pElement.Name;
                     pData.value:= pElement.Gewicht;
                     pData.typ:= Element;
                     pData.size:= FormelIMG.Canvas.TextWidth(pElement.Symbol);
                   end;
                 end;
               end;


          Daten.Add(pData);
        end;

      end;
    end;
    strlist.free;
  end;
  DLG.Free;
  TXTZeiger:= Daten.Count +1;
  WriteDaten(nil);
  CalcBTNClick(self);
end;

procedure TMainForm.MSaveClick(Sender: TObject);
var DLG     : TSaveDialog;
    strlist : TStringList;
    pData   : TDaten;
    i       : integer;
begin
  DLG:= TSaveDialog.Create(self);
  DLG.InitialDir:= Pfad + WORKDIR;
  DLG.DefaultExt:= '.txt';
  DLG.Title:= 'Formel speichern';
  DLG.Filter:= 'FORMEL|*.txt';
  DLG.FilterIndex:= 0;
  if DLG.Execute then
  begin
    strlist:= TStringlist.Create;

    if Daten.Count > 0 then
    begin
      for i:= 0 to Daten.Count-1 do
      begin
        pData:= Daten.Items[i];
        if pData <> nil then
        begin
          if pData.typ = Multiplikator then strlist.Add('|' + pData.xs)
             else strlist.Add(pData.xs);
        end;
      end;
    end;

    strlist.savetofile(DLG.Filename);
    strlist.Free;
  end;
  DLG.Free;
end;

procedure TMainForm.MHilfe1Click(Sender: TObject);
var DLG : THilfeBox;
begin
  DLG:= THilfeBox.Create(self);
  DLG.ShowModal;
  DLG.Free;
end;

procedure TMainForm.MInfoClick(Sender: TObject);
var DLG : TAboutBox;
begin
  DLG:= TAboutBox.Create(self);
  DLG.ShowModal;
  DLG.Free;
end;

procedure TMainForm.MCloseClick(Sender: TObject);
begin
  close;
end;

end.
