unit u_myfloat;

interface
{
type
    FLOATZAHL = record
       Z,NK,n : integer;
              end;
}

var edkomma : boolean;

procedure initfloat;
function komma : boolean;
function my_strtofloat(s : string) : single;
function my_floattostr(f : single; vk,nk : integer) : string;
function my_strtodouble(s : string) : double;
function my_doubletostr(f : double; vk,nk : integer) : string;
{
procedure my_strtofloat_int(s : string; var x : FLOATZAHL);
function my_floattostr_int(x : FLOATZAHL; n : integer) : string;
procedure my_float_add_int(var R,X1,X2 : FLOATZAHL);
procedure my_float_mul_int(var R,X1,X2 : FLOATZAHL);
procedure my_float_round_int(var R : FLOATZAHL; n: integer);
function my_floatzahl(X : FLOATZAHL) : double;
function my_doubletofloatzahl(f : double; n : integer) : FLOATZAHL;
}

implementation
uses sysutils;

function komma : boolean;
begin
  result:= false;
  try
    strtofloat('3,5');
    result:= true;
  except
    result:= false;
  end;

  edkomma:= result;
end;

procedure initfloat;
begin
  komma;
end;

function my_strtofloat(s : string) : single;
var n  : integer;
    sx : string;
begin
  sx:= s;
  result:= 0;
  if sx <> '' then
  begin
    if edkomma then  //deutsch
    begin
      n:= pos('.',sx);
      if n > 0 then sx[n]:= ',';
      result:= strtofloat(sx);
    end
    else begin  //english
           n:= pos(',',sx);
           if n > 0 then sx[n]:= '.';
           result:= strtofloat(sx);
         end;
  end;
end;

function my_floattostr(f : single; vk,nk : integer) : string;
begin
  result:= floattostrF(f,ffFixed,vk+nk,nk);
end;


function my_strtodouble(s : string) : double;
var n  : integer;
    sx : string;
begin
  sx:= s;
  result:= 0;
  if sx <> '' then
  begin
    if edkomma then  //deutsch
    begin
      n:= pos('.',sx);
      if n > 0 then sx[n]:= ',';
      result:= strtofloat(sx);
    end
    else begin  //english
           n:= pos(',',sx);
           if n > 0 then sx[n]:= '.';
           result:= strtofloat(sx);
         end;
  end;
end;

function my_doubletostr(f : double; vk,nk : integer) : string;
begin
  result:= floattostrF(f,ffFixed,vk+nk,nk);
end;

//FLOAT als INTEGER
{
procedure my_strtofloat_int(s : string; var x : FLOATZAHL);
var i  : integer;
    sx : string;
begin
  sx:= s;
  x.Z:= 0;
  x.NK:= 0;

  if sx <> '' then
  begin
    if edkomma then i:= pos('.',sx)  //deutsch
               else i:= pos(',',sx); //english

    x.Z:= strtointdef(copy(sx,1,i-1),0);
    sx:= copy(sx,i+1,length(sx)-i);
    sx:= copy(sx,1,x.n);
    while length(sx) < x.n do
       sx:= sx + '0';

    x.NK:= strtointdef(sx,0);
  end;
end;

function my_floattostr_int(x : FLOATZAHL; n : integer) : string;
var s,sx : string;
begin
  x.n:= n;
  s:= inttostr(x.Z);
    if edkomma then s:= s + '.'  //deutsch
               else s:= s + ','; //english

  sx:= inttostr(x.NK);
  while length(sx) < n do
     sx:= '0' + sx;
  s:= s + copy(sx,1,n);
  result:= s;
end;

procedure my_float_add_int(var R,X1,X2 : FLOATZAHL);
var i,k : integer;
begin
  R.n:= X1.n;
  R.Z:=  X1.Z  + X2.Z;
  R.NK:= X1.NK + X2.NK;

  k:= R.NK;
  for i:= 0 to R.n-1 do
     k:= k div 10;
  R.Z:= R.Z + k;

  for i:= 0 to R.n-1 do
     k:= k * 10;
  R.NK:= R.NK - k;
end;

procedure my_float_mul_int(var R,X1,X2 : FLOATZAHL);
var i,k : integer;
begin
  R.n:= X1.n;
  R.Z:= X1.Z * X2.Z;

  if R.n > 3 then
  begin
    k:= 1;
    for i:= 0 to X1.n-3-1 do
      k:= k * 10;
    R.NK:= (X1.NK div k) * (X2.NK div k);
  end
  else R.NK:=  X1.NK * X2.NK;

  R.NK:= R.NK + X1.NK * X2.Z;
  R.NK:= R.NK + X2.NK * X1.Z;

  k:= 1;
  for i:= 0 to X1.n-1 do
    k:= k * 10;

  i:= R.NK div k;
  R.Z:= R.Z + i;
  R.NK:= R.NK - i*k;
end;

procedure my_float_round_int(var R : FLOATZAHL; n: integer);
var m,x,k,i : integer;
begin
  x:= R.NK;
  m:= 0;
  while x > 0 do
  begin
    x:= x div 10;
    inc(m);
  end;

  if m > n then
  begin
    m:= m - n;
    x:= R.NK;
    for i:= 1 to m-1 do
       x:= x div 10;

    k:= x div 10;
    k:= k * 10;
    k:= x - k;

    x:= x div 10;
    if k >= 5 then x:= x +1;

    for i:= 1 to m do
      x:= x * 10;
    R.NK:= x;
  end;
end;

function my_floatzahl(X : FLOATZAHL) : double;
var f_zahl : double;
    i      : integer;
begin
  f_zahl:= X.NK;

  for i:= 0 to X.n -1 do
    f_zahl:= f_zahl / 10;

  f_zahl:= f_zahl + X.Z;
  result:= f_zahl;
end;

function my_doubletofloatzahl(f : double; n : integer) : FLOATZAHL;
var X : FLOATZAHL;
    i,k : integer;
begin
  X.n:= n;

  k:= 1;
  for i:= 0 to X.n-1 do
    k:= k * 10;

  X.Z:= TRUNC(f);
  X.NK:= TRUNC((f - X.Z) * k);
  result:= X;
end;
}
end.
