unit u_viewelement;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,  ExtCtrls, clipbrd, u_myfloat, u_data, u_element, u_inifile;

type
  TElementViewForm = class(TForm)
    Panel1: TPanel;
    OKBTN: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ElementTXT: TLabel;
    SymbolTXT: TLabel;
    OrdnungszahlTXT: TLabel;
    MasseTXT: TLabel;
    GruppeTXT: TLabel;
    PeriodeTXT: TLabel;
    constructor Create(AOwner : TComponent; pPSE : TList; IniFile : TIniFile);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure OKBTNClick(Sender: TObject);
  private
    { Private-Deklarationen }
    PSE      : TList;
    pElement : TElement;
    IniDatei : TIniFile;
  public
    { Public-Deklarationen }
  end;

var
  ElementViewForm: TElementViewForm;

implementation

{$R *.DFM}

const ZahlenArray : Array[1..8] of string = ('I','II','III','IV','V','VI','VII','VIII');


constructor TElementViewForm.Create(AOwner : TComponent; pPSE : TList; IniFile : TIniFile);
begin
  inherited Create(AOwner);
  PSE:= pPSE;
  pElement:= nil;
  IniDatei:= IniFile;
end;

procedure TElementViewForm.FormCreate(Sender: TObject);
begin
  pElement:= nil;
  OKBTN.Left:= clientwidth div 2 - OKBTN.Width div 2;
end;

procedure TElementViewForm.FormResize(Sender: TObject);
begin
  OKBTN.Left:= clientwidth div 2 - OKBTN.Width div 2;
end;

procedure TElementViewForm.FormShow(Sender: TObject);
var DLG  : TElementForm;
    s    : string;
begin
  DLG:= TElementForm.Create(self,PSE);
  DLG.ShowModal;
  pElement:= DLG.getElement;
  DLG.Free;
  if pElement <> nil then
  begin
    ElementTXT.Caption:= pElement.Name;
    SymbolTXT.Caption:=  pElement.Symbol;
    OrdnungszahlTXT.Caption:= inttostr(pElement.Position);
    MasseTXT.Caption:= my_doubletostr(pElement.Gewicht,3,3);

    s:= ZahlenArray[pElement.HauptGruppe];
    if pElement.Nebengruppe then s:= s + 'b'
                            else s:= s + 'a';
    if pElement.Lanthanoide then s:= s + ' (Lanthanide)';
    if pElement.Actinoide   then s:= s + ' (Aktinide)';
    GruppeTXT.Caption:=  s;
    PeriodeTXT.Caption:= inttostr(pElement.Periode);

    if IniDatei.readmemofunction then
    begin
      s:= my_doubletostr(pElement.Gewicht,3,5);
      if IniDatei.readeinheit then Clipboard.AsText:= s + ' g/mol'
                              else Clipboard.AsText:= s;
    end;
  end;
end;

procedure TElementViewForm.OKBTNClick(Sender: TObject);
begin
  close;
end;

end.
